diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/rate-control/amrr-wifi-manager.h ns-3.34/src/wifi/model/rate-control/amrr-wifi-manager.h
--- ns-3.33/src/wifi/model/rate-control/amrr-wifi-manager.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/rate-control/amrr-wifi-manager.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,161 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2003,2007 INRIA
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
+ */
+
+#ifndef AMRR_WIFI_MANAGER_H
+#define AMRR_WIFI_MANAGER_H
+
+#include "ns3/traced-value.h"
+#include "ns3/wifi-remote-station-manager.h"
+
+namespace ns3 {
+
+struct AmrrWifiRemoteStation;
+
+/**
+ * \brief AMRR Rate control algorithm
+ * \ingroup wifi
+ *
+ * This class implements the AMRR rate control algorithm which
+ * was initially described in <i>IEEE 802.11 Rate Adaptation:
+ * A Practical Approach</i>, by M. Lacage, M.H. Manshaei, and
+ * T. Turletti.
+ *
+ * This RAA does not support HT modes and will error
+ * exit if the user tries to configure this RAA with a Wi-Fi MAC
+ * that supports 802.11n or higher.
+ */
+class AmrrWifiManager : public WifiRemoteStationManager
+{
+public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+
+  AmrrWifiManager ();
+  virtual ~AmrrWifiManager ();
+
+
+private:
+  void DoInitialize (void) override;
+  WifiRemoteStation * DoCreateStation (void) const override;
+  void DoReportRxOk (WifiRemoteStation *station,
+                     double rxSnr, WifiMode txMode) override;
+  void DoReportRtsFailed (WifiRemoteStation *station) override;
+  void DoReportDataFailed (WifiRemoteStation *station) override;
+  void DoReportRtsOk (WifiRemoteStation *station,
+                      double ctsSnr, WifiMode ctsMode, double rtsSnr) override;
+  void DoReportDataOk (WifiRemoteStation *station, double ackSnr, WifiMode ackMode,
+                       double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss) override;
+  void DoReportFinalRtsFailed (WifiRemoteStation *station) override;
+  void DoReportFinalDataFailed (WifiRemoteStation *station) override;
+  WifiTxVector DoGetDataTxVector (WifiRemoteStation *station) override;
+  WifiTxVector DoGetRtsTxVector (WifiRemoteStation *station) override;
+
+  /**
+   * Update the mode used to send to the given station.
+   *
+   * \param station the remote station state
+   */
+  void UpdateMode (AmrrWifiRemoteStation *station);
+  /**
+   * Reset transmission statistics of the given station.
+   *
+   * \param station the remote station state
+   */
+  void ResetCnt (AmrrWifiRemoteStation *station);
+  /**
+   * Increase the transmission rate to the given station.
+   *
+   * \param station the remote station state
+   */
+  void IncreaseRate (AmrrWifiRemoteStation *station);
+  /**
+   * Decrease the transmission rate to the given station.
+   *
+   * \param station the remote station state
+   */
+  void DecreaseRate (AmrrWifiRemoteStation *station);
+  /**
+   * Check if the current rate for the given station is the
+   * minimum rate.
+   *
+   * \param station the remote station state
+   *
+   * \return true if the current rate is the minimum rate,
+   *         false otherwise
+   */
+  bool IsMinRate (AmrrWifiRemoteStation *station) const;
+  /**
+   * Check if the current rate for the given station is the
+   * maximum rate.
+   *
+   * \param station the remote station state
+   *
+   * \return true if the current rate is the maximum rate,
+   *         false otherwise
+   */
+  bool IsMaxRate (AmrrWifiRemoteStation *station) const;
+  /**
+   * Check if the number of retransmission and transmission error
+   * is less than the number of successful transmission (times ratio).
+   *
+   * \param station the remote station state
+   *
+   * \return true if the number of retransmission and transmission error
+   *              is less than the number of successful transmission
+   *              (times ratio), false otherwise
+   */
+  bool IsSuccess (AmrrWifiRemoteStation *station) const;
+  /**
+   * Check if the number of retransmission and transmission error
+   * is greater than the number of successful transmission (times ratio).
+   *
+   * \param station the remote station state
+   *
+   * \return true if the number of retransmission and transmission error
+   *              is less than the number of successful transmission
+   *              (times ratio), false otherwise
+   */
+  bool IsFailure (AmrrWifiRemoteStation *station) const;
+  /**
+   * Check if the number of retransmission, transmission error,
+   * and successful transmission are greater than 10.
+   *
+   * \param station the remote station state
+   * \return true if the number of retransmission, transmission error,
+   *         and successful transmission are greater than 10,
+   *         false otherwise
+   */
+  bool IsEnough (AmrrWifiRemoteStation *station) const;
+
+  Time m_updatePeriod;            ///< update period
+  double m_failureRatio;          ///< failure ratio
+  double m_successRatio;          ///< success ratio
+  uint32_t m_maxSuccessThreshold; ///< maximum success threshold
+  uint32_t m_minSuccessThreshold; ///< minimum success threshold
+
+  TracedValue<uint64_t> m_currentRate; //!< Trace rate changes
+};
+
+} //namespace ns3
+
+#endif /* AMRR_WIFI_MANAGER_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/rate-control/aparf-wifi-manager.cc ns-3.34/src/wifi/model/rate-control/aparf-wifi-manager.cc
--- ns-3.33/src/wifi/model/rate-control/aparf-wifi-manager.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/rate-control/aparf-wifi-manager.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,393 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2014 Universidad de la República - Uruguay
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Matias Richart <mrichart@fing.edu.uy>
+ */
+
+#include "ns3/log.h"
+#include "ns3/uinteger.h"
+#include "ns3/data-rate.h"
+#include "aparf-wifi-manager.h"
+#include "ns3/wifi-phy.h"
+
+#define Min(a,b) ((a < b) ? a : b)
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("AparfWifiManager");
+
+/**
+ * Hold per-remote-station state for APARF Wifi manager.
+ *
+ * This struct extends from WifiRemoteStation struct to hold additional
+ * information required by the APARF Wifi manager
+ */
+struct
+AparfWifiRemoteStation : public WifiRemoteStation
+{
+  uint32_t m_nSuccess;                  //!< Number of successful transmission attempts.
+  uint32_t m_nFailed;                   //!< Number of failed transmission attempts.
+  uint32_t m_pCount;                    //!< Number of power changes.
+  uint32_t m_successThreshold;          //!< The minimum number of successful transmissions to try a new power or rate.
+  uint32_t m_failThreshold;             //!< The minimum number of failed transmissions to try a new power or rate.
+  uint8_t m_prevRateIndex;              //!< Rate index of the previous transmission.
+  uint8_t m_rateIndex;                  //!< Current rate index.
+  uint8_t m_critRateIndex;              //!< Critical rate.
+  uint8_t m_prevPowerLevel;             //!< Power level of the previous transmission.
+  uint8_t m_powerLevel;                 //!< Current power level.
+  uint8_t m_nSupported;                 //!< Number of supported rates by the remote station.
+  bool m_initialized;                   //!< For initializing variables.
+  AparfWifiManager::State m_aparfState; //!< The estimated state of the channel.
+};
+
+NS_OBJECT_ENSURE_REGISTERED (AparfWifiManager);
+
+TypeId
+AparfWifiManager::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::AparfWifiManager")
+    .SetParent<WifiRemoteStationManager> ()
+    .SetGroupName ("Wifi")
+    .AddConstructor<AparfWifiManager> ()
+    .AddAttribute ("SuccessThreshold1",
+                   "The minimum number of successful transmissions in \"High\" state to try a new power or rate.",
+                   UintegerValue (3),
+                   MakeUintegerAccessor (&AparfWifiManager::m_succesMax1),
+                   MakeUintegerChecker<uint32_t> ())
+    .AddAttribute ("SuccessThreshold2",
+                   "The minimum number of successful transmissions in \"Low\" state to try a new power or rate.",
+                   UintegerValue (10),
+                   MakeUintegerAccessor (&AparfWifiManager::m_succesMax2),
+                   MakeUintegerChecker<uint32_t> ())
+    .AddAttribute ("FailThreshold",
+                   "The minimum number of failed transmissions to try a new power or rate.",
+                   UintegerValue (1),
+                   MakeUintegerAccessor (&AparfWifiManager::m_failMax),
+                   MakeUintegerChecker<uint32_t> ())
+    .AddAttribute ("PowerThreshold",
+                   "The maximum number of power changes.",
+                   UintegerValue (10),
+                   MakeUintegerAccessor (&AparfWifiManager::m_powerMax),
+                   MakeUintegerChecker<uint32_t> ())
+    .AddAttribute ("PowerDecrementStep",
+                   "Step size for decrement the power.",
+                   UintegerValue (1),
+                   MakeUintegerAccessor (&AparfWifiManager::m_powerDec),
+                   MakeUintegerChecker<uint8_t> ())
+    .AddAttribute ("PowerIncrementStep",
+                   "Step size for increment the power.",
+                   UintegerValue (1),
+                   MakeUintegerAccessor (&AparfWifiManager::m_powerInc),
+                   MakeUintegerChecker<uint8_t> ())
+    .AddAttribute ("RateDecrementStep",
+                   "Step size for decrement the rate.",
+                   UintegerValue (1),
+                   MakeUintegerAccessor (&AparfWifiManager::m_rateDec),
+                   MakeUintegerChecker<uint8_t> ())
+    .AddAttribute ("RateIncrementStep",
+                   "Step size for increment the rate.",
+                   UintegerValue (1),
+                   MakeUintegerAccessor (&AparfWifiManager::m_rateInc),
+                   MakeUintegerChecker<uint8_t> ())
+    .AddTraceSource ("PowerChange",
+                     "The transmission power has change",
+                     MakeTraceSourceAccessor (&AparfWifiManager::m_powerChange),
+                     "ns3::WifiRemoteStationManager::PowerChangeTracedCallback")
+    .AddTraceSource ("RateChange",
+                     "The transmission rate has change",
+                     MakeTraceSourceAccessor (&AparfWifiManager::m_rateChange),
+                     "ns3::WifiRemoteStationManager::RateChangeTracedCallback")
+  ;
+  return tid;
+}
+
+AparfWifiManager::AparfWifiManager ()
+{
+  NS_LOG_FUNCTION (this);
+}
+
+AparfWifiManager::~AparfWifiManager ()
+{
+  NS_LOG_FUNCTION (this);
+}
+
+void
+AparfWifiManager::SetupPhy (const Ptr<WifiPhy> phy)
+{
+  NS_LOG_FUNCTION (this << phy);
+  m_minPower = 0;
+  m_maxPower = phy->GetNTxPower () - 1;
+  WifiRemoteStationManager::SetupPhy (phy);
+}
+
+void
+AparfWifiManager::DoInitialize ()
+{
+  NS_LOG_FUNCTION (this);
+  if (GetHtSupported ())
+    {
+      NS_FATAL_ERROR ("WifiRemoteStationManager selected does not support HT rates");
+    }
+  if (GetVhtSupported ())
+    {
+      NS_FATAL_ERROR ("WifiRemoteStationManager selected does not support VHT rates");
+    }
+  if (GetHeSupported ())
+    {
+      NS_FATAL_ERROR ("WifiRemoteStationManager selected does not support HE rates");
+    }
+}
+
+WifiRemoteStation *
+AparfWifiManager::DoCreateStation (void) const
+{
+  NS_LOG_FUNCTION (this);
+  AparfWifiRemoteStation *station = new AparfWifiRemoteStation ();
+
+  station->m_successThreshold = m_succesMax1;
+  station->m_failThreshold = m_failMax;
+  station->m_nSuccess = 0;
+  station->m_nFailed = 0;
+  station->m_pCount = 0;
+  station->m_aparfState = AparfWifiManager::High;
+  station->m_initialized = false;
+
+  NS_LOG_DEBUG ("create station=" << station << ", rate=" << +station->m_rateIndex
+                                  << ", power=" << +station->m_powerLevel);
+
+  return station;
+}
+
+void
+AparfWifiManager::CheckInit (AparfWifiRemoteStation *station)
+{
+  if (!station->m_initialized)
+    {
+      station->m_nSupported = GetNSupported (station);
+      station->m_rateIndex = station->m_nSupported - 1;
+      station->m_prevRateIndex = station->m_nSupported - 1;
+      station->m_powerLevel = m_maxPower;
+      station->m_prevPowerLevel = m_maxPower;
+      station->m_critRateIndex = 0;
+      WifiMode mode = GetSupported (station, station->m_rateIndex);
+      uint16_t channelWidth = GetChannelWidth (station);
+      DataRate rate = DataRate (mode.GetDataRate (channelWidth));
+      double power = GetPhy ()->GetPowerDbm (m_maxPower);
+      m_powerChange (power, power, station->m_state->m_address);
+      m_rateChange (rate, rate, station->m_state->m_address);
+      station->m_initialized = true;
+    }
+}
+
+void AparfWifiManager::DoReportRtsFailed (WifiRemoteStation *station)
+{
+  NS_LOG_FUNCTION (this << station);
+}
+
+void AparfWifiManager::DoReportDataFailed (WifiRemoteStation *st)
+{
+  NS_LOG_FUNCTION (this << st);
+  AparfWifiRemoteStation *station = static_cast<AparfWifiRemoteStation*> (st);
+  CheckInit (station);
+  station->m_nFailed++;
+  station->m_nSuccess = 0;
+  NS_LOG_DEBUG ("station=" << station << ", rate=" << station->m_rateIndex
+                           << ", power=" << (int)station->m_powerLevel);
+
+  if (station->m_aparfState == AparfWifiManager::Low)
+    {
+      station->m_aparfState = AparfWifiManager::High;
+      station->m_successThreshold = m_succesMax1;
+    }
+  else if (station->m_aparfState == AparfWifiManager::Spread)
+    {
+      station->m_aparfState = AparfWifiManager::Low;
+      station->m_successThreshold = m_succesMax2;
+    }
+
+  if (station->m_nFailed == station->m_failThreshold)
+    {
+      station->m_nFailed = 0;
+      station->m_nSuccess = 0;
+      station->m_pCount = 0;
+      if (station->m_powerLevel == m_maxPower)
+        {
+          station->m_critRateIndex = station->m_rateIndex;
+          if (station->m_rateIndex != 0)
+            {
+              NS_LOG_DEBUG ("station=" << station << " dec rate");
+              station->m_rateIndex -= m_rateDec;
+            }
+        }
+      else
+        {
+          NS_LOG_DEBUG ("station=" << station << " inc power");
+          station->m_powerLevel += m_powerInc;
+        }
+    }
+}
+
+void
+AparfWifiManager::DoReportRxOk (WifiRemoteStation *station, double rxSnr, WifiMode txMode)
+{
+  NS_LOG_FUNCTION (this << station << rxSnr << txMode);
+}
+
+void
+AparfWifiManager::DoReportRtsOk (WifiRemoteStation *station, double ctsSnr,
+                                 WifiMode ctsMode, double rtsSnr)
+{
+  NS_LOG_FUNCTION (this << station << ctsSnr << ctsMode << rtsSnr);
+}
+
+void
+AparfWifiManager::DoReportDataOk (WifiRemoteStation *st, double ackSnr, WifiMode ackMode,
+                                  double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss)
+{
+  NS_LOG_FUNCTION (this << st << ackSnr << ackMode << dataSnr << dataChannelWidth << +dataNss);
+  AparfWifiRemoteStation *station = static_cast<AparfWifiRemoteStation*> (st);
+  CheckInit (station);
+  station->m_nSuccess++;
+  station->m_nFailed = 0;
+  NS_LOG_DEBUG ("station=" << station << " data ok success=" << station->m_nSuccess << ", rate=" << +station->m_rateIndex << ", power=" << +station->m_powerLevel);
+
+  if ((station->m_aparfState == AparfWifiManager::High) && (station->m_nSuccess >= station->m_successThreshold))
+    {
+      station->m_aparfState = AparfWifiManager::Spread;
+    }
+  else if ((station->m_aparfState == AparfWifiManager::Low) && (station->m_nSuccess >= station->m_successThreshold))
+    {
+      station->m_aparfState = AparfWifiManager::Spread;
+    }
+  else if (station->m_aparfState == AparfWifiManager::Spread)
+    {
+      station->m_aparfState = AparfWifiManager::High;
+      station->m_successThreshold = m_succesMax1;
+    }
+
+  if (station->m_nSuccess == station->m_successThreshold)
+    {
+      station->m_nSuccess = 0;
+      station->m_nFailed = 0;
+      if (station->m_rateIndex == (station->m_state->m_operationalRateSet.size () - 1))
+        {
+          if (station->m_powerLevel != m_minPower)
+            {
+              NS_LOG_DEBUG ("station=" << station << " dec power");
+              station->m_powerLevel -= m_powerDec;
+            }
+        }
+      else
+        {
+          if (station->m_critRateIndex == 0)
+            {
+              if (station->m_rateIndex != (station->m_state->m_operationalRateSet.size () - 1))
+                {
+                  NS_LOG_DEBUG ("station=" << station << " inc rate");
+                  station->m_rateIndex += m_rateInc;
+                }
+            }
+          else
+            {
+              if (station->m_pCount == m_powerMax)
+                {
+                  station->m_powerLevel = m_maxPower;
+                  station->m_rateIndex = station->m_critRateIndex;
+                  station->m_pCount = 0;
+                  station->m_critRateIndex = 0;
+                }
+              else
+                {
+                  if (station->m_powerLevel != m_minPower)
+                    {
+                      station->m_powerLevel -= m_powerDec;
+                      station->m_pCount++;
+                    }
+                }
+            }
+        }
+    }
+}
+
+void
+AparfWifiManager::DoReportFinalRtsFailed (WifiRemoteStation *station)
+{
+  NS_LOG_FUNCTION (this << station);
+}
+
+void
+AparfWifiManager::DoReportFinalDataFailed (WifiRemoteStation *station)
+{
+  NS_LOG_FUNCTION (this << station);
+}
+
+WifiTxVector
+AparfWifiManager::DoGetDataTxVector (WifiRemoteStation *st)
+{
+  NS_LOG_FUNCTION (this << st);
+  AparfWifiRemoteStation *station = static_cast<AparfWifiRemoteStation*> (st);
+  uint16_t channelWidth = GetChannelWidth (station);
+  if (channelWidth > 20 && channelWidth != 22)
+    {
+      channelWidth = 20;
+    }
+  CheckInit (station);
+  WifiMode mode = GetSupported (station, station->m_rateIndex);
+  DataRate rate = DataRate (mode.GetDataRate (channelWidth));
+  DataRate prevRate = DataRate (GetSupported (station, station->m_prevRateIndex).GetDataRate (channelWidth));
+  double power = GetPhy ()->GetPowerDbm (station->m_powerLevel);
+  double prevPower = GetPhy ()->GetPowerDbm (station->m_prevPowerLevel);
+  if (station->m_prevPowerLevel != station->m_powerLevel)
+    {
+      m_powerChange (prevPower, power, station->m_state->m_address);
+      station->m_prevPowerLevel = station->m_powerLevel;
+    }
+  if (station->m_prevRateIndex != station->m_rateIndex)
+    {
+      m_rateChange (prevRate, rate, station->m_state->m_address);
+      station->m_prevRateIndex = station->m_rateIndex;
+    }
+  return WifiTxVector (mode, station->m_powerLevel, GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
+}
+
+WifiTxVector
+AparfWifiManager::DoGetRtsTxVector (WifiRemoteStation *st)
+{
+  NS_LOG_FUNCTION (this << st);
+  /// \todo we could/should implement the ARF algorithm for
+  /// RTS only by picking a single rate within the BasicRateSet.
+  AparfWifiRemoteStation *station = static_cast<AparfWifiRemoteStation*> (st);
+  uint16_t channelWidth = GetChannelWidth (station);
+  if (channelWidth > 20 && channelWidth != 22)
+    {
+      channelWidth = 20;
+    }
+  WifiTxVector rtsTxVector;
+  WifiMode mode;
+  if (GetUseNonErpProtection () == false)
+    {
+      mode = GetSupported (station, 0);
+    }
+  else
+    {
+      mode = GetNonErpSupported (station, 0);
+    }
+  rtsTxVector = WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled ()), 800, 1, 1, 0, channelWidth, GetAggregation (station));
+  return rtsTxVector;
+}
+
+} //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/rate-control/aparf-wifi-manager.h ns-3.34/src/wifi/model/rate-control/aparf-wifi-manager.h
--- ns-3.33/src/wifi/model/rate-control/aparf-wifi-manager.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/rate-control/aparf-wifi-manager.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,124 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2014 Universidad de la República - Uruguay
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Matias Richart <mrichart@fing.edu.uy>
+ */
+
+#ifndef APARF_WIFI_MANAGER_H
+#define APARF_WIFI_MANAGER_H
+
+#include "ns3/wifi-remote-station-manager.h"
+
+namespace ns3 {
+
+struct AparfWifiRemoteStation;
+
+/**
+ * \ingroup wifi
+ * APARF Power and rate control algorithm
+ *
+ * This class implements the High Performance power and rate control algorithm
+ * described in <i>Dynamic data rate and transmit power adjustment
+ * in IEEE 802.11 wireless LANs</i> by Chevillat, P.; Jelitto, J.
+ * and Truong, H. L. in International Journal of Wireless Information
+ * Networks, Springer, 2005, 12, 123-145.
+ * http://www.cs.mun.ca/~yzchen/papers/papers/rate_adaptation/80211_dynamic_rate_power_adjustment_chevillat_j2005.pdf
+ *
+ * This RAA does not support HT modes and will error
+ * exit if the user tries to configure this RAA with a Wi-Fi MAC
+ * that supports 802.11n or higher.
+ */
+class AparfWifiManager : public WifiRemoteStationManager
+{
+public:
+  /**
+   * Register this type.
+   * \return The object TypeId.
+   */
+  static TypeId GetTypeId (void);
+  AparfWifiManager ();
+  virtual ~AparfWifiManager ();
+
+  void SetupPhy (const Ptr<WifiPhy> phy) override;
+
+  /**
+   * Enumeration of the possible states of the channel.
+   */
+  enum State
+  {
+    High,
+    Low,
+    Spread
+  };
+
+
+private:
+  void DoInitialize (void) override;
+  WifiRemoteStation * DoCreateStation (void) const override;
+  void DoReportRxOk (WifiRemoteStation *station,
+                     double rxSnr, WifiMode txMode) override;
+  void DoReportRtsFailed (WifiRemoteStation *station) override;
+  void DoReportDataFailed (WifiRemoteStation *station) override;
+  void DoReportRtsOk (WifiRemoteStation *station,
+                      double ctsSnr, WifiMode ctsMode, double rtsSnr) override;
+  void DoReportDataOk (WifiRemoteStation *station, double ackSnr, WifiMode ackMode,
+                       double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss) override;
+  void DoReportFinalRtsFailed (WifiRemoteStation *station) override;
+  void DoReportFinalDataFailed (WifiRemoteStation *station) override;
+  WifiTxVector DoGetDataTxVector (WifiRemoteStation *station) override;
+  WifiTxVector DoGetRtsTxVector (WifiRemoteStation *station) override;
+
+  /** Check for initializations.
+   *
+   * \param station The remote station.
+   */
+  void CheckInit (AparfWifiRemoteStation *station);
+
+  uint32_t m_succesMax1; //!< The minimum number of successful transmissions in \"High\" state to try a new power or rate.
+  uint32_t m_succesMax2; //!< The minimum number of successful transmissions in \"Low\" state to try a new power or rate.
+  uint32_t m_failMax;    //!< The minimum number of failed transmissions to try a new power or rate.
+  uint32_t m_powerMax;   //!< The maximum number of power changes.
+  uint8_t m_powerInc;    //!< Step size for increment the power.
+  uint8_t m_powerDec;    //!< Step size for decrement the power.
+  uint8_t m_rateInc;     //!< Step size for increment the rate.
+  uint8_t m_rateDec;     //!< Step size for decrement the rate.
+
+  /**
+   * Minimal power level.
+   * Differently form rate, power levels do not depend on the remote station.
+   * The levels depend only on the physical layer of the device.
+   */
+  uint8_t m_minPower;
+
+  /**
+   * Maximal power level.
+   */
+  uint8_t m_maxPower;
+
+  /**
+   * The trace source fired when the transmission power changes.
+   */
+  TracedCallback<double, double, Mac48Address> m_powerChange;
+  /**
+   * The trace source fired when the transmission rate changes.
+   */
+  TracedCallback<DataRate, DataRate, Mac48Address> m_rateChange;
+};
+
+} //namespace ns3
+
+#endif /* APARF_WIFI_MANAGER_H */
